{*
 * Projecte Fressa a LINKAT
 * FUNCIONS WIN 32
 *
 * Author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 *}

unit UnitFormRegressioIntroduirValors;

{*******************************************************************************}
interface
{*******************************************************************************}
{
uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QGrids, QButtons, QExtCtrls;
}
uses
  SysUtils, WinTypes, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Buttons, ExtCtrls;

type
  TFormNumericaRegressio = class(TForm)
    StringGridValorsNumerica: TStringGrid;
    BitBtnSeguent: TBitBtn;
    BitBtnAnterior: TBitBtn;
    BitBtnInserir: TBitBtn;
    BitBtnSuprimir: TBitBtn;
    BitBtnIniciar: TBitBtn;
    BitBtnEnganxar: TBitBtn;
    BitBtnCopiar: TBitBtn;
    BitBtnDAcord: TBitBtn;
    BitBtnCancelar: TBitBtn;
    BitBtnAjuda: TBitBtn;
    Panel1: TPanel;
    Panel2: TPanel;
    Bevel1: TBevel;
    MemoClipboard: TMemo;
    BitBtnCoeficients: TBitBtn;
    RadioButtonLineal: TRadioButton;
    RadioButtonQuadratica: TRadioButton;
    RadioButtonExponencial: TRadioButton;
    RadioButtonPotencial: TRadioButton;
    RadioButtonInversa: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure StringGridValorsNumericaKeyPress(Sender: TObject;var Key: Char);
    procedure BitBtnDAcordClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BitBtnSeguentClick(Sender: TObject);
    procedure BitBtnAnteriorClick(Sender: TObject);
    procedure BitBtnInserirClick(Sender: TObject);
    procedure BitBtnSuprimirClick(Sender: TObject);
    procedure BitBtnIniciarClick(Sender: TObject);
    procedure BitBtnCopiarClick(Sender: TObject);
    procedure BitBtnEnganxarClick(Sender: TObject);
    procedure BitBtnCoeficientsClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    PucCoefExp:boolean;
    Function CalcularUltimLLoc:integer;
  end;

var
  FormNumericaRegressio: TFormNumericaRegressio;

{*******************************************************************************}
implementation
{*******************************************************************************}

uses UnitCalcular, UnitFormEntradaDeDades, UnitVariables, UnitCalcularRegressio,
  UnitFormCoeficientsRegressio, UnitTools, Clipbrd;

{$R *.dfm}

procedure TFormNumericaRegressio.FormCreate(Sender: TObject);
var
  i:integer;
begin
  StringGridValorsNumerica.ColWidths[0]:=StringGridValorsNumerica.ColWidths[0]-35;
  StringGridValorsNumerica.Cells[1,0]:='X';
  StringGridValorsNumerica.Cells[2,0]:='F(x)';
  for i:=1 to 500 do StringGridValorsNumerica.Cells[0,i]:=IntToStr(i);
end;

procedure TFormNumericaRegressio.FormActivate(Sender: TObject);
begin
  StringGridValorsNumerica.SetFocus;
end;

{*******************************************************************************}
procedure TFormNumericaRegressio.StringGridValorsNumericaKeyPress(Sender: TObject; var Key: Char);
begin
  if (Ord(Key)=13) {or (Ord(Key)=9)} then begin
    if StringGridValorsNumerica.Col=1 then begin
      StringGridValorsNumerica.Col:=2;
    end else begin
      if StringGridValorsNumerica.Row<500 then begin
        StringGridValorsNumerica.Col:=1;
        StringGridValorsNumerica.Row:=StringGridValorsNumerica.Row+1;
      end;
    end;
  end;
end;

{*******************************************************************************}
procedure TFormNumericaRegressio.BitBtnSeguentClick(Sender: TObject);
begin
  if StringGridValorsNumerica.Col=1 then begin
    StringGridValorsNumerica.Col:=2;
  end else begin
    if StringGridValorsNumerica.Row<500 then begin
      StringGridValorsNumerica.Col:=1;
      StringGridValorsNumerica.Row:=StringGridValorsNumerica.Row+1;
    end;
  end;
  StringGridValorsNumerica.SetFocus;
end;

procedure TFormNumericaRegressio.BitBtnAnteriorClick(Sender: TObject);
begin
  if StringGridValorsNumerica.Col=2 then begin
    StringGridValorsNumerica.Col:=1;
  end else begin
    if StringGridValorsNumerica.Row>1 then begin
      StringGridValorsNumerica.Col:=2;
      StringGridValorsNumerica.Row:=StringGridValorsNumerica.Row-1;
    end;
  end;
  StringGridValorsNumerica.SetFocus;
end;

procedure TFormNumericaRegressio.BitBtnInserirClick(Sender: TObject);
var
  i:integer;
begin
  if StringGridValorsNumerica.Row<500 then begin
    for i:=499 downto StringGridValorsNumerica.Row do begin
      StringGridValorsNumerica.Cells[1,i+1]:=StringGridValorsNumerica.Cells[1,i];
      StringGridValorsNumerica.Cells[2,i+1]:=StringGridValorsNumerica.Cells[2,i];
    end;
    StringGridValorsNumerica.Cells[1,StringGridValorsNumerica.Row]:='';
    StringGridValorsNumerica.Cells[2,StringGridValorsNumerica.Row]:='';
  end;
  StringGridValorsNumerica.Col:=1;
  StringGridValorsNumerica.SetFocus;
end;

procedure TFormNumericaRegressio.BitBtnSuprimirClick(Sender: TObject);
var
  i:integer;
begin
  for i:=StringGridValorsNumerica.Row to 499 do begin
    StringGridValorsNumerica.Cells[1,i]:=StringGridValorsNumerica.Cells[1,i+1];
    StringGridValorsNumerica.Cells[2,i]:=StringGridValorsNumerica.Cells[2,i+1];
  end;
  StringGridValorsNumerica.Cells[1,500]:='';
  StringGridValorsNumerica.Cells[2,500]:='';
  StringGridValorsNumerica.Col:=1;
  StringGridValorsNumerica.SetFocus;
end;

procedure TFormNumericaRegressio.BitBtnIniciarClick(Sender: TObject);
var
  i:integer;
begin
  if Application.MessageBox(PChar(missatges[224]),PChar(CaptionFuncions),MB_YESNO+MB_ICONQUESTION)=idYes then begin
    for i:=1 to 500 do begin
      StringGridValorsNumerica.Cells[1,i]:='';
      StringGridValorsNumerica.Cells[2,i]:='';
    end;
  end;
  StringGridValorsNumerica.Col:=1;
  StringGridValorsNumerica.Row:=1;
  StringGridValorsNumerica.SetFocus;
end;

Function TFormNumericaRegressio.CalcularUltimLLoc:integer;
var
  i:integer;
begin
  CalcularUltimLLoc:=0;
  for i:=1 to 500 do if (StringGridValorsNumerica.Cells[1,i]<>'') or (StringGridValorsNumerica.Cells[2,i]<>'') then CalcularUltimLLoc:=i;
end;

procedure TFormNumericaRegressio.BitBtnCopiarClick(Sender: TObject);
var
  i,UltimLloc:integer;
begin
  UltimLloc:=CalcularUltimLLoc;
  if UltimLloc>0 then begin
    MemoClipboard.Clear;
    //MemoClipboard.Text:='X'+#9+'F(X)';
    for i:=1 to UltimLloc do MemoClipboard.Lines.Append(StringGridValorsNumerica.Cells[1,i]+#9+StringGridValorsNumerica.Cells[2,i]);
    {
    MemoClipboard.SelectAll;
    MemoClipboard.CopyToClipboard;
    }
    Clipboard.AsText:=MemoClipboard.Text;
  end;
  StringGridValorsNumerica.SetFocus;
end;

procedure TFormNumericaRegressio.BitBtnEnganxarClick(Sender: TObject);
var
  s1:string;
  i,n,UltimLloc:integer;
  VaDeDosAmbDos:boolean;
begin
  if Application.MessageBox(PChar(missatges[225]),PChar(CaptionFuncions),MB_YESNO+MB_ICONQUESTION)=idYes then begin
    StringGridValorsNumerica.SetFocus;
    MemoClipboard.Clear;
    //MemoClipboard.PasteFromClipboard;
    MemoClipboard.Text:=Clipboard.AsText;
    if MemoClipboard.Text='' then begin
      Application.MessageBox(PChar(missatges[226]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
      exit;
    end;
    //37
    for i:=0 to MemoClipboard.Lines.Count do begin
      StringGridValorsNumerica.Cells[1,i+1]:='';
      StringGridValorsNumerica.Cells[2,i+1]:='';
    end;
    //37
    VaDeDosAmbDos:=true;
    for i:=0 to MemoClipboard.Lines.Count do begin
      s1:=MemoClipboard.Lines[i];
      if s1<>'' then begin
        n:=Pos(#9,s1);
        if n=0 then begin
          //Application.MessageBox(PChar(missatges[227]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
          VaDeDosAmbDos:=false;
          break;
        end else begin
          StringGridValorsNumerica.Cells[1,i+1]:=Copy(s1,1,n-1);
          StringGridValorsNumerica.Cells[2,i+1]:=Copy(s1,n+1,length(s1)-n);
        end;
      end else begin
        break;
      end;
    end;
    if not(VaDeDosAmbDos) then begin
      for i:=0 to MemoClipboard.Lines.Count do begin
        StringGridValorsNumerica.Cells[1,i+1]:='';
        StringGridValorsNumerica.Cells[2,i+1]:='';
      end;
      for i:=0 to MemoClipboard.Lines.Count do begin
        s1:=MemoClipboard.Lines[i];
        if s1<>'' then begin
          if i mod 2=0 then begin
            StringGridValorsNumerica.Cells[1,(i+2)div 2]:=s1;
          end else begin
            StringGridValorsNumerica.Cells[2,(i+1)div 2]:=s1;
          end;
        end else begin
          break;
        end;
      end;
    end;
    UltimLloc:=CalcularUltimLLoc;
    StringGridValorsNumerica.Col:=1;
    if UltimLloc=500 then StringGridValorsNumerica.Row:=UltimLloc else StringGridValorsNumerica.Row:=UltimLloc+1;
  end;
  StringGridValorsNumerica.SetFocus;
end;

{*******************************************************************************}
procedure TFormNumericaRegressio.BitBtnCoeficientsClick(Sender: TObject);
var
  i,n:integer;
  r1,r2:real;
  ErrorCalcul:integer;
  BooleanCoeCorr:boolean;
  DesQuadMitja:real;
begin
  for i:=1 to NumericaMax do begin
    if StringGridValorsNumerica.Cells[1,i]<>'' then begin
      r1:=CalcularCurrency(StringGridValorsNumerica.Cells[1,i],ErrorCalcul);
      if ErrorCalcul<>0 then begin
        StringGridValorsNumerica.Col:=1;
        StringGridValorsNumerica.Row:=i;
        Application.MessageBox(PChar(missatges[228]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
      r2:=CalcularCurrency(StringGridValorsNumerica.Cells[2,i],ErrorCalcul);
      if ErrorCalcul<>0 then begin
        StringGridValorsNumerica.Col:=2;
        StringGridValorsNumerica.Row:=i;
        Application.MessageBox(PChar(missatges[228]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
      FnP[1,i]:=r1;
      FnP[2,i]:=r2;
    end else begin
      if i<4 then begin
        StringGridValorsNumerica.Col:=1;
        StringGridValorsNumerica.Row:=1;
        Application.MessageBox(PChar(missatges[232]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
      for n:=i to NumericaMax do begin
        if (StringGridValorsNumerica.Cells[1,n]<>'') then begin
          StringGridValorsNumerica.Col:=1;
          StringGridValorsNumerica.Row:=n;
          Application.MessageBox(PChar(missatges[231]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
          StringGridValorsNumerica.SetFocus;
          exit;
        end else if (StringGridValorsNumerica.Cells[2,n]<>'') then begin
          StringGridValorsNumerica.Col:=2;
          StringGridValorsNumerica.Row:=n;
          Application.MessageBox(PChar(missatges[231]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
          StringGridValorsNumerica.SetFocus;
          exit;
        end;
      end;
      break;
    end;
  end;
  if i=Numericamax then Ul:=i else Ul:=i-1;
  MaximX[Qfn]:=FnP[1,1];
  MinimX[Qfn]:=FnP[1,1];
  MaximY[Qfn]:=FnP[2,1];
  MinimY[Qfn]:=FnP[2,1];
  for n:=2 to Ul do begin
    if FnP[1,n]>MaximX[Qfn] then MaximX[Qfn]:=FnP[1,n];
    if FnP[1,n]<MinimX[Qfn] then MinimX[Qfn]:=FnP[1,n];
    if FnP[2,n]>MaximY[Qfn] then MaximY[Qfn]:=FnP[2,n];
    if FnP[2,n]<MinimY[Qfn] then MinimY[Qfn]:=FnP[2,n];
  end;
  Lloc[Qfn]:=Ll;
  UltimLloc[Qfn]:=Ul;
  FNB[Qfn]:=true;
  for i:=1 to NumericaMax do begin
    FN[Qfn,1,i]:=FnP[1,i];
    FN[Qfn,2,i]:=FnP[2,i];
  end;
  FormCoeficients.Label351.Caption:=RealToStringALillonessima(MinimX[Qfn]);
  FormCoeficients.Label352.Caption:=RealToStringALillonessima(MinimY[Qfn]);
  FormCoeficients.Label353.Caption:=RealToStringALillonessima(MaximX[Qfn]);
  FormCoeficients.Label354.Caption:=RealToStringALillonessima(MaximY[Qfn]);
  BooleanCoeCorr:=CalcularCoeficientsCorrelacio(Qfn,1);

  if BooleanCoeCorr then begin
    AReg[Qfn]:=Covariancia[Qfn]/SQR(DesviacioTipusX[Qfn]);
    BReg[Qfn]:=MitjanaY[Qfn]-AReg[Qfn]*MitjanaX[Qfn];
    FNRegressio[Qfn]:=RealToStringALillonessima(AReg[Qfn])+'x ';
    //76
    //if BReg[Qfn]>=0 then FNRegressio[Qfn]:=FNRegressio[Qfn]+'+ ';
    if RealToMillonessima(BReg[Qfn])>=0 then FNRegressio[Qfn]:=FNRegressio[Qfn]+'+ ';
    FNRegressio[Qfn]:=FNRegressio[Qfn]+RealToStringALillonessima(BReg[Qfn]);
    FormCoeficients.Label355.Caption:=RealToStringALillonessima(MitjanaX[Qfn]);
    FormCoeficients.Label356.Caption:=RealToStringALillonessima(MitjanaY[Qfn]);
    FormCoeficients.Label357.Caption:=RealToStringALillonessima(DesviacioTipusX[Qfn]);
    FormCoeficients.Label358.Caption:=RealToStringALillonessima(DesviacioTipusY[Qfn]);
    FormCoeficients.Label359.Caption:=RealToStringALillonessima(Covariancia[Qfn]);
    FormCoeficients.Label360.Caption:='ax+b ->';
    FormCoeficients.Label361.Caption:=RealToStringALillonessima(CoeficientDeCorrelacio[Qfn]);
    DesQuadMitja:=0;
    for i:=1 to Ul do DesQuadMitja:=DesQuadMitja+sqr((FnP[2,i]-(AReg[Qfn]*FnP[1,i]+BReg[Qfn])));
    DesQuadMitja:=DesQuadMitja/Ul;
    FormCoeficients.Label362.Caption:=RealToStringALillonessima(DesQuadMitja);
    {
    LoadString(HInstance,160,Text,SizeOf(Text));
    s4:=StrPas(Text);
    s2:=s2+s4+RealToStringALillonessima(MitjanaX[Qfn])+#13#10;
    LoadString(HInstance,161,Text,SizeOf(Text));
    s4:=StrPas(Text);
    s2:=s2+s4+RealToStringALillonessima(MitjanaY[Qfn])+#13#10#13#10;
    LoadString(HInstance,162,Text,SizeOf(Text));
    s4:=StrPas(Text);
    s2:=s2+s4+RealToStringALillonessima(DesviacioTipusX[Qfn])+#13#10;
    LoadString(HInstance,163,Text,SizeOf(Text));
    s4:=StrPas(Text);
    s2:=s2+s4+RealToStringALillonessima(DesviacioTipusY[Qfn])+#13#10#13#10;
    LoadString(HInstance,164,Text,SizeOf(Text));
    s4:=StrPas(Text);
    s2:=s2+s4+RealToStringALillonessima(Covariancia[Qfn])+#13#10#13#10;
    LoadString(HInstance,165,Text,SizeOf(Text));
    s4:=StrPas(Text);
    s2:=s2+s4+#13#10#13#10;
    LoadString(HInstance,166,Text,SizeOf(Text));
    }
    //EscriuCoeCorr;
  end else begin
    FormCoeficients.Label360.Caption:='ax+b ->';
    FormCoeficients.Label361.Caption:='NO';
  end;
  if Parabolica then begin
    FormCoeficients.Label363.Caption:='ax^2+bx+c ->';
    FormCoeficients.Label364.Caption:=RealToStringALillonessima(CoeficientDeCorrelacio[Qfn]);
    DesQuadMitja:=0;
    for i:=1 to Ul do DesQuadMitja:=DesQuadMitja+sqr(FnP[2,i]-(AReg[Qfn]*sqr(FnP[1,i])+BReg[Qfn]*FnP[1,i]+CReg[Qfn]));
    DesQuadMitja:=DesQuadMitja/Ul;
    FormCoeficients.Label365.Caption:=RealToStringALillonessima(DesQuadMitja);
    {
    LoadString(HInstance,167,Text,SizeOf(Text));
    EscriuCoeCorr;
    }
  end else begin
    FormCoeficients.Label363.Caption:='ax^2+bx+c ->';
    FormCoeficients.Label364.Caption:='NO';
  end;
  PucCoefExp:=false;
  if CalcularCoeficientsCorrelacio(Qfn,3) then begin
    PucCoefExp:=true;
    AReg[Qfn]:=Covariancia[Qfn]/SQR(DesviacioTipusX[Qfn]);
    BReg[Qfn]:=MitjanaY[Qfn]-AReg[Qfn]*MitjanaX[Qfn];
    if (not((AReg[Qfn]>-88) and (AReg[Qfn]<88))) or (not((BReg[Qfn]>-88) and (BReg[Qfn]<88))) then PucCoefExp:=false;
  end;
  if PucCoefExp then begin
    FNRegressio[Qfn]:=RealToStringALillonessima(exp(BReg[Qfn]))+' * '+RealToStringALillonessima(exp(AReg[Qfn]))+'^x';
    FormCoeficients.Label366.Caption:='a.b^x ->';
    FormCoeficients.Label367.Caption:=RealToStringALillonessima(CoeficientDeCorrelacio[Qfn]);
    DesQuadMitja:=0;
    for i:=1 to Ul do DesQuadMitja:=DesQuadMitja+sqr(FnP[2,i]-(exp(BReg[Qfn])*exp(AReg[Qfn]*FnP[1,i])));
    DesQuadMitja:=DesQuadMitja/Ul;
    FormCoeficients.Label368.Caption:=RealToStringALillonessima(DesQuadMitja);
    {
    LoadString(HInstance,168,Text,SizeOf(Text));
    EscriuCoeCorr;
    }
  end else begin
    FormCoeficients.Label366.Caption:='a.b^x ->';
    FormCoeficients.Label367.Caption:='NO';
  end;
  PucCoefExp:=false;
  if CalcularCoeficientsCorrelacio(Qfn,4) then begin
    PucCoefExp:=true;
    AReg[Qfn]:=Covariancia[Qfn]/SQR(DesviacioTipusX[Qfn]);
    BReg[Qfn]:=MitjanaY[Qfn]-AReg[Qfn]*MitjanaX[Qfn];
    if not((BReg[Qfn]>-88) and (BReg[Qfn]<88)) then PucCoefExp:=false;
  end;
  if PucCoefExp then begin
    FNRegressio[Qfn]:=RealToStringALillonessima(exp(BReg[Qfn]))+' * x^'+RealToStringALillonessima((AReg[Qfn]));
    FormCoeficients.Label369.Caption:='a.x^b ->';
    FormCoeficients.Label370.Caption:=RealToStringALillonessima(CoeficientDeCorrelacio[Qfn]);
    DesQuadMitja:=0;
    for i:=1 to Ul do DesQuadMitja:=DesQuadMitja+sqr(FnP[2,i]-(exp(BReg[Qfn])*exp(AReg[Qfn]*ln(FnP[1,i]))));
    DesQuadMitja:=DesQuadMitja/Ul;
    FormCoeficients.Label371.Caption:=RealToStringALillonessima(DesQuadMitja);
    {
    LoadString(HInstance,169,Text,SizeOf(Text));
    EscriuCoeCorr;
    }
  end else begin
    FormCoeficients.Label369.Caption:='a.x^b ->';
    FormCoeficients.Label370.Caption:='NO';
  end;

  PucCoefExp:=false;
  if CalcularCoeficientsCorrelacio(Qfn,5) then begin
    PucCoefExp:=true;
    AReg[Qfn]:=Covariancia[Qfn]/SQR(DesviacioTipusX[Qfn]);
    BReg[Qfn]:=MitjanaY[Qfn]-AReg[Qfn]*MitjanaX[Qfn];
    if not(abs(BReg[Qfn])>1.0E-19) then PucCoefExp:=false;
  end;
  if PucCoefExp then begin
    FNRegressio[Qfn]:=RealToStringALillonessima(1/BReg[Qfn])+' * x/('+RealToStringALillonessima((AReg[Qfn]/BReg[Qfn]))+'+x)';
    FormCoeficients.Label372.Caption:='ax/(b+x) ->';
    FormCoeficients.Label373.Caption:=RealToStringALillonessima(CoeficientDeCorrelacio[Qfn]);
    DesQuadMitja:=0;
    for i:=1 to Ul do DesQuadMitja:=DesQuadMitja+sqr(FnP[2,i]-(1/BReg[Qfn])* FnP[1,i]/(AReg[Qfn]/BReg[Qfn]+FnP[1,i]));
    DesQuadMitja:=DesQuadMitja/Ul;
    FormCoeficients.Label374.Caption:=RealToStringALillonessima(DesQuadMitja);
    {
    LoadString(HInstance,194,Text,SizeOf(Text));
    EscriuCoeCorr;
    }
  end else begin
    FormCoeficients.Label372.Caption:='ax/(b+x) ->';
    FormCoeficients.Label373.Caption:='NO';
  end;

  FormCoeficients.ShowModal;
end;

procedure TFormNumericaRegressio.BitBtnDAcordClick(Sender: TObject);
var
  i,n:integer;
  r1,r2:real;
  ErrorCalcul:integer;
  titol:string;
begin
  for i:=1 to NumericaMax do begin
    if StringGridValorsNumerica.Cells[1,i]<>'' then begin
      r1:=CalcularCurrency(StringGridValorsNumerica.Cells[1,i],ErrorCalcul);
      if ErrorCalcul<>0 then begin
        StringGridValorsNumerica.Col:=1;
        StringGridValorsNumerica.Row:=i;
        Application.MessageBox(PChar(missatges[228]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
      r2:=CalcularCurrency(StringGridValorsNumerica.Cells[2,i],ErrorCalcul);
      if ErrorCalcul<>0 then begin
        StringGridValorsNumerica.Col:=2;
        StringGridValorsNumerica.Row:=i;
        Application.MessageBox(PChar(missatges[228]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
      FnP[1,i]:=r1;
      FnP[2,i]:=r2;
    end else begin
      if i<4 then begin
        StringGridValorsNumerica.Col:=1;
        StringGridValorsNumerica.Row:=1;
        Application.MessageBox(PChar(missatges[232]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
      for n:=i to NumericaMax do begin
        if (StringGridValorsNumerica.Cells[1,n]<>'') then begin
          StringGridValorsNumerica.Col:=1;
          StringGridValorsNumerica.Row:=n;
          Application.MessageBox(PChar(missatges[231]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
          StringGridValorsNumerica.SetFocus;
          exit;
        end else if (StringGridValorsNumerica.Cells[2,n]<>'') then begin
          StringGridValorsNumerica.Col:=2;
          StringGridValorsNumerica.Row:=n;
          Application.MessageBox(PChar(missatges[231]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
          StringGridValorsNumerica.SetFocus;
          exit;
        end;
      end;
      break;
    end;
  end;
  if i=Numericamax then Ul:=i else Ul:=i-1;
  MaximX[Qfn]:=FnP[1,1];
  MinimX[Qfn]:=FnP[1,1];
  MaximY[Qfn]:=FnP[2,1];
  MinimY[Qfn]:=FnP[2,1];
  for n:=2 to Ul do begin
    if FnP[1,n]>MaximX[Qfn] then MaximX[Qfn]:=FnP[1,n];
    if FnP[1,n]<MinimX[Qfn] then MinimX[Qfn]:=FnP[1,n];
    if FnP[2,n]>MaximY[Qfn] then MaximY[Qfn]:=FnP[2,n];
    if FnP[2,n]<MinimY[Qfn] then MinimY[Qfn]:=FnP[2,n];
  end;
  Lloc[Qfn]:=Ll;
  UltimLloc[Qfn]:=Ul;
  FNB[Qfn]:=true;
  for i:=1 to NumericaMax do begin
    FN[Qfn,1,i]:=FnP[1,i];
    FN[Qfn,2,i]:=FnP[2,i];
  end;
  if FormNumericaRegressio.RadioButtonLineal.Checked then begin
    if CalcularCoeficientsCorrelacio(Qfn,1) then begin
      AReg[Qfn]:=Covariancia[Qfn]/SQR(DesviacioTipusX[Qfn]);
      BReg[Qfn]:=MitjanaY[Qfn]-AReg[Qfn]*MitjanaX[Qfn];
      CReg[Qfn]:=0;
      FNRegressio[Qfn]:=RealToStringALillonessima(AReg[Qfn])+'x ';
      //76
      //if BReg[Qfn]>=0 then FNRegressio[Qfn]:=FNRegressio[Qfn]+'+ ';
      if RealToMillonessima(BReg[Qfn])>=0 then FNRegressio[Qfn]:=FNRegressio[Qfn]+'+ ';
      FNRegressio[Qfn]:=FNRegressio[Qfn]+RealToStringALillonessima(BReg[Qfn]);
    end else begin
      Application.MessageBox(PChar(missatges[233]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
      StringGridValorsNumerica.SetFocus;
      exit;
    end;
    TipusRegressio[Qfn]:=1;
    Titol:=FunReLineal;
  end else if FormNumericaRegressio.RadioButtonQuadratica.Checked then begin
    for i:=1 to Ul do begin
      if abs(FnP[1,i])>=100000 then begin
        StringGridValorsNumerica.Col:=1;
        StringGridValorsNumerica.Row:=i;
        Application.MessageBox(PChar(missatges[234]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
      if abs(FnP[2,i])>=100000 then begin
        StringGridValorsNumerica.Col:=2;
        StringGridValorsNumerica.Row:=i;
        Application.MessageBox(PChar(missatges[234]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
    end;
    if not Parabolica then begin
      Application.MessageBox(PChar(missatges[236]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
      StringGridValorsNumerica.SetFocus;
      exit;
    end;
    TipusRegressio[Qfn]:=2;
    Titol:=FunReCuad;
  end else if FormNumericaRegressio.RadioButtonExponencial.Checked then begin
    for i:=1 to Ul do begin
      if abs(FnP[1,i])>=100000 then begin
        StringGridValorsNumerica.Col:=1;
        StringGridValorsNumerica.Row:=i;
        Application.MessageBox(PChar(missatges[237]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
      if FnP[2,i]>=100000 then begin
        StringGridValorsNumerica.Col:=2;
        StringGridValorsNumerica.Row:=i;
        Application.MessageBox(PChar(missatges[238]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
      if FnP[2,i]<=0 then begin
        StringGridValorsNumerica.Col:=2;
        StringGridValorsNumerica.Row:=i;
        Application.MessageBox(PChar(missatges[239]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
    end;
    PucCoefExp:=true;
    if CalcularCoeficientsCorrelacio(Qfn,3) then begin
      AReg[Qfn]:=Covariancia[Qfn]/SQR(DesviacioTipusX[Qfn]);
      BReg[Qfn]:=MitjanaY[Qfn]-AReg[Qfn]*MitjanaX[Qfn];
      CReg[Qfn]:=0;
      if not((AReg[Qfn]>-88) and (AReg[Qfn]<88)) then PucCoefExp:=false;
      if not((BReg[Qfn]>-88) and (BReg[Qfn]<88)) then PucCoefExp:=false;
    end;
    if PucCoefExp then begin
      FNRegressio[Qfn]:=RealToStringALillonessima(exp(BReg[Qfn]))+' * ('+RealToStringALillonessima(exp(AReg[Qfn]))+')^x';
    end else begin
      StringGridValorsNumerica.Col:=2;
      StringGridValorsNumerica.Row:=1;
      Application.MessageBox(PChar(missatges[240]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
      StringGridValorsNumerica.SetFocus;
      exit;
    end;
    TipusRegressio[Qfn]:=3;
    Titol:=FunReEx;
  end else if FormNumericaRegressio.RadioButtonPotencial.Checked then begin
    for i:=1 to Ul do begin
      if FnP[1,i]<=0 then begin
        StringGridValorsNumerica.Col:=1;
        StringGridValorsNumerica.Row:=i;
        Application.MessageBox(PChar(missatges[241]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
      if FnP[2,i]<=0 then begin
        StringGridValorsNumerica.Col:=2;
        StringGridValorsNumerica.Row:=i;
        Application.MessageBox(PChar(missatges[241]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
    end;
    PucCoefExp:=true;
    if CalcularCoeficientsCorrelacio(Qfn,4) then begin
      AReg[Qfn]:=Covariancia[Qfn]/SQR(DesviacioTipusX[Qfn]);
      BReg[Qfn]:=MitjanaY[Qfn]-AReg[Qfn]*MitjanaX[Qfn];
      CReg[Qfn]:=0;
      if not((BReg[Qfn]>-88) and (BReg[Qfn]<88)) then PucCoefExp:=false;
    end;
    if PucCoefExp then begin
      FNRegressio[Qfn]:=RealToStringALillonessima(exp(BReg[Qfn]))+' * x^('+RealToStringALillonessima((AReg[Qfn]))+')';
    end else begin
      StringGridValorsNumerica.Col:=1;
      StringGridValorsNumerica.Row:=1;
      Application.MessageBox(PChar(missatges[242]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
      StringGridValorsNumerica.SetFocus;
      exit;
    end;
    TipusRegressio[Qfn]:=4;
    Titol:=FunReEx2;
  end else if FormNumericaRegressio.RadioButtonInversa.Checked then begin
    PucCoefExp:=true;
    if CalcularCoeficientsCorrelacio(Qfn,5) then begin
      AReg[Qfn]:=Covariancia[Qfn]/SQR(DesviacioTipusX[Qfn]);
      BReg[Qfn]:=MitjanaY[Qfn]-AReg[Qfn]*MitjanaX[Qfn];
      CReg[Qfn]:=0;
      if not(abs(BReg[Qfn])>1.0E-19) then PucCoefExp:=false;
      if PucCoefExp then begin
        FNRegressio[Qfn]:=RealToStringALillonessima(1/BReg[Qfn])+' * x/('+RealToStringALillonessima((AReg[Qfn]/BReg[Qfn]))+'+x)';
      end else begin
        StringGridValorsNumerica.Col:=1;
        StringGridValorsNumerica.Row:=1;
        Application.MessageBox(PChar(missatges[243]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
    end else begin
      StringGridValorsNumerica.Col:=1;
      StringGridValorsNumerica.Row:=1;
      Application.MessageBox(PChar(missatges[243]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
      StringGridValorsNumerica.SetFocus;
      exit;
    end;
    TipusRegressio[Qfn]:=5;
    Titol:=FunReInv;
  end;
  if Qfn=1 then begin
    FormEntradaDeDades.EditF.Text:=Titol;
  end else if Qfn=2 then begin
    FormEntradaDeDades.EditG.Text:=Titol;
  end else if Qfn=3 then begin
    FormEntradaDeDades.EditH.Text:=Titol;
  end else if Qfn=4 then begin
    FormEntradaDeDades.EditI.Text:=Titol;
  end else if Qfn=5 then begin
    FormEntradaDeDades.EditJ.Text:=Titol;
  end else if Qfn=6 then begin
    FormEntradaDeDades.EditK.Text:=Titol;
  end;
  ResultatNumericaRegressio:=1;
  Close;
end;

end.
