{*
 * Projecte Fressa a LINKAT
 * FUNCIONS WIN 32
 *
 * Author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 *}

unit UnitFormUnaFuncio;

{*******************************************************************************}
interface
{*******************************************************************************}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Buttons;

type
  TFormUnaFuncio = class(TForm)
    Panel1: TPanel;
    EditUnaFuncio: TComboBox;
    ComboBoxFuncio: TComboBox;
    BitBtnContinuar: TBitBtn;
    BitBtn2: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ComboBoxFuncioChange(Sender: TObject);
    procedure EditUnaFuncioChange(Sender: TObject);
    procedure BitBtnContinuarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormUnaFuncio: TFormUnaFuncio;

{*******************************************************************************}
implementation
{*******************************************************************************}

uses UnitCalcular, UnitFormPrincipal, Unitvariables, UnitTools,
  UnitFormEntradaDeDades, UnitCalcularFuncioNumerica;

{$R *.DFM}

procedure TFormUnaFuncio.FormCreate(Sender: TObject);
begin
  ComboBoxFuncio.ItemIndex:=0;
end;

procedure TFormUnaFuncio.FormActivate(Sender: TObject);
begin
  case ComboBoxFuncio.ItemIndex of
    0: EditUnaFuncio.Text:=FormEntradaDeDades.EditF.Text;
    1: EditUnaFuncio.Text:=FormEntradaDeDades.EditG.Text;
    2: EditUnaFuncio.Text:=FormEntradaDeDades.EditH.Text;
    3: EditUnaFuncio.Text:=FormEntradaDeDades.EditI.Text;
    4: EditUnaFuncio.Text:=FormEntradaDeDades.EditJ.Text;
    5: EditUnaFuncio.Text:=FormEntradaDeDades.EditK.Text;
  end;
end;

procedure TFormUnaFuncio.ComboBoxFuncioChange(Sender: TObject);
begin
  case ComboBoxFuncio.ItemIndex of
    0: EditUnaFuncio.Text:=FormEntradaDeDades.EditF.Text;
    1: EditUnaFuncio.Text:=FormEntradaDeDades.EditG.Text;
    2: EditUnaFuncio.Text:=FormEntradaDeDades.EditH.Text;
    3: EditUnaFuncio.Text:=FormEntradaDeDades.EditI.Text;
    4: EditUnaFuncio.Text:=FormEntradaDeDades.EditJ.Text;
    5: EditUnaFuncio.Text:=FormEntradaDeDades.EditK.Text;
  end;
end;

procedure TFormUnaFuncio.EditUnaFuncioChange(Sender: TObject);
var
  ErrorAnalisi,LlocError:integer;
begin
  if EditUnaFuncio.ItemIndex>-1 then begin
    if EditUnaFuncio.Text<>'' then begin
      if not EsFuncioNumerica(EditUnaFuncio.Text) then begin
        analitzar(EditUnaFuncio.Text,ErrorAnalisi,LlocError);
        if ErrorAnalisi<>0 then begin
          exit;
        end;
      end;
    end;
    case ComboBoxFuncio.ItemIndex of
      0: FormEntradaDeDades.EditF.Text:=EditUnaFuncio.Text;
      1: FormEntradaDeDades.EditG.Text:=EditUnaFuncio.Text;
      2: FormEntradaDeDades.EditH.Text:=EditUnaFuncio.Text;
      3: FormEntradaDeDades.EditI.Text:=EditUnaFuncio.Text;
      4: FormEntradaDeDades.EditJ.Text:=EditUnaFuncio.Text;
      5: FormEntradaDeDades.EditK.Text:=EditUnaFuncio.Text;
    end;
    Entrada[1]:=FormEntradaDeDades.EditF.Text;
    Entrada[2]:=FormEntradaDeDades.EditG.Text;
    Entrada[3]:=FormEntradaDeDades.EditH.Text;
    Entrada[4]:=FormEntradaDeDades.EditI.Text;
    Entrada[5]:=FormEntradaDeDades.EditJ.Text;
    Entrada[6]:=FormEntradaDeDades.EditK.Text;
    FormPrincipal.MenuCanviarFuncionsOParametresDAcord;
  end;
end;

procedure TFormUnaFuncio.BitBtnContinuarClick(Sender: TObject);
var
  ErrorAnalisi,LlocError:integer;
begin
  if EditUnaFuncio.Text<>'' then begin
    if not EsFuncioNumerica(EditUnaFuncio.Text) then begin
      analitzar(EditUnaFuncio.Text,ErrorAnalisi,LlocError);
      if ErrorAnalisi<>0 then begin
        Application.MessageBox(PChar(missatges[219]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        EditUnaFuncio.SetFocus;
        exit;
      end;
    end;
  end;
  case ComboBoxFuncio.ItemIndex of
    0: FormEntradaDeDades.EditF.Text:=EditUnaFuncio.Text;
    1: FormEntradaDeDades.EditG.Text:=EditUnaFuncio.Text;
    2: FormEntradaDeDades.EditH.Text:=EditUnaFuncio.Text;
    3: FormEntradaDeDades.EditI.Text:=EditUnaFuncio.Text;
    4: FormEntradaDeDades.EditJ.Text:=EditUnaFuncio.Text;
    5: FormEntradaDeDades.EditK.Text:=EditUnaFuncio.Text;
  end;
  Entrada[1]:=FormEntradaDeDades.EditF.Text;
  Entrada[2]:=FormEntradaDeDades.EditG.Text;
  Entrada[3]:=FormEntradaDeDades.EditH.Text;
  Entrada[4]:=FormEntradaDeDades.EditI.Text;
  Entrada[5]:=FormEntradaDeDades.EditJ.Text;
  Entrada[6]:=FormEntradaDeDades.EditK.Text;
  FormPrincipal.MenuCanviarFuncionsOParametresDAcord;
end;

end.
