{*
 * Projecte Fressa a LINKAT
 * FUNCIONS WIN 32
 *
 * Author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 *}

unit UnitTools;

{*******************************************************************************}
interface
{*******************************************************************************}

uses Graphics, Math;

Function ArrodonirAEnter(V:Real):Integer;
Function Arrodonir(V:Real):Longint;
Function RealToString(V:Real):String;
Function Aprox(Valor:Real):Real;
Function Maxim(Valor1,Valor2:Real):Real; {Funci donats 2 reals torna el gran}
Function Minim(Valor1,Valor2:Real):Real; {Funci donats 2 reals torna el petit}
Function FToSToRealToString(V:Real):String;

//22/07/05-Serveixen per mostrar la precisi en els clculs. Quan est acivada la precisi baixa no tinc clar que funcioni b
Function RealToStringX(V,Idx:Real):String;
Function RealToStringY(V,Idy:Real):String;
//
Function RealToStringALillonessima(V:Real):String;
Function RealToMillonessima(V:Real):Real;

function GetProgramAssociation (Ext:string):string;
procedure AssociarExtensio(Ext,s:string);
Function CasMay(s: string): string;

procedure AALine(x1,y1,x2,y2 : single; color : tcolor; canvas : tcanvas);
procedure DrawAntialisedLine(Canvas: TCanvas; const AX1, AY1, AX2, AY2: real; const LineColor: TColor);

{*******************************************************************************}
implementation
{*******************************************************************************}

uses SysUtils, Registry, Windows;

Function RealToStringALillonessima(V:Real):String;
begin
  RealToStringALillonessima:=FloatToStr(Round(V*1000000)/1000000);
end;

//76
Function RealToMillonessima(V:Real):Real;
begin
  RealToMillonessima:=Round(V*1000000)/1000000;
end;

Function ArrodonirAEnter(V:Real):Integer;
begin
  if v>32000 then begin
    ArrodonirAEnter:=32000;
  end else if v<-32000 then begin
    ArrodonirAEnter:=-32000;
  end else begin
    ArrodonirAEnter:=Round(v);
  end;
end;

Function Arrodonir(V:Real):Longint;
begin
  if v>2000000000 then begin
    Arrodonir:=2000000000;
  end else if v<-2000000000 then begin
    Arrodonir:=-2000000000;
  end else begin
    Arrodonir:=Round(v);
  end;
end;

Function FToSToRealToString(V:Real):String;
begin
  //FToSToRealToString:=FloatToStr(V);
  FToSToRealToString:=RealToString(V);
end;

Function RealToString(V:Real):String;
var
  s:string;
  d,i,n:integer;
begin
  RealToString:=RealToStringALillonessima(V);
  exit;
  if v>100000 then v:=int(v);
  if V=Arrodonir(V) then begin
    Str(V:1:0,s);
    RealToString:= s;
  end else begin
    Str(V:1:6,s);
    d:=length(s);
    for i:=d downto d-6 do begin
      if Copy(s,i,1)<>'0' then begin
        n:=i;
        //i:=d-6;
        Break;
      end;
      if Copy(s,n,1)='.' then n:=n-1;
      RealToString:=Copy(s,1,n);
    end;
  end;
end;

Function Aprox(Valor:Real):Real;
begin
  if abs(Valor) > 1000000000 then begin
    Aprox:=Valor;
  end else if abs(Valor) > 300000 then begin
    Aprox:= Arrodonir(Valor);
  end else if abs(Valor) > 30000 then begin
    Aprox:= Arrodonir(10*Valor)/10;
  end else if abs(Valor) > 3000 then begin
    Aprox:= Arrodonir(100*Valor)/100;
  end else if abs(Valor) > 300 then begin
    Aprox:= Arrodonir(1000*Valor)/1000;
  end else if abs(Valor) > 30 then begin
    Aprox:= Arrodonir(10000*Valor)/10000;
  end else if abs(Valor) > 3 then begin
    Aprox:= Arrodonir(100000*Valor)/100000;
  end else if abs(Valor) > 0.3 then begin
    Aprox:= Arrodonir(1000000*Valor)/1000000;
  end else begin
    Aprox:= Arrodonir(10000000*Valor)/10000000;
  end;
end;

Function PasarADecimals(V:real;nd:integer):Real;
var
  m:LongInt;
  i:integer;
begin
  PasarADecimals:=V;
  if nd<1 then exit;
  m:=1;
  for i:=1 to nd do m:=m*10;
  V:=Round(V*m);
  V:=V/m;
  PasarADecimals:=V;
end;

Function RealToStringX(V,Idx:Real):String;
var
  s:string;
  d,i,n:integer;
  ND:integer;
  Resultat:string;
begin
  Resultat:='';
  if v>100000 then v:=int(v);
  if V=Arrodonir(V) then begin
    Str(V:1:0,s);
    Resultat:= s;
  end else begin
    {nd:=length(RealToString(Frac(Aprox(Idx))))-2;}
    nd:=6;
    s:=RealToString(Frac(Aprox(Idx)));
    d:=length(s);
    for i:=3 to d do begin
      if Copy(s,i,1)<>'0' then begin
        nd:= i-2;
        break;
      end;
    end;
    {
    //BEGIN v: 10 01/01/06
    v:=PasarADecimals(V,nd);
    s:=RealToString(V);
    RealToStringX:=s;
    exit;
    //END v: 10 01/01/06
    }
    Str(V:1:nd,s);
    d:=length(s);
    for i:=d downto d-nd do begin
      if Copy(s,i,1)<>'0' then begin
        n:=i;
        //BEGIN v: 10 01/01/06
        if Copy(s,n,1)='.' then n:=n-1;
        Resultat:=Copy(s,1,n);
        //END v: 10 01/01/06
        break;
      end;
      if Copy(s,n,1)='.' then n:=n-1;
      Resultat:=Copy(s,1,n);
    end;
  end;
  i:=Pos('.',Resultat);
  if i<>0 then begin
    Delete(Resultat,i,1);
    Insert(',',Resultat,i);
  end;
  RealToStringX:=Resultat;
end;

Function RealToStringY(V,Idy:Real):String;
var
  s:string;
  d,i,n:integer;
  ND:integer;
  Resultat:string;
begin
  Resultat:='';
  if V>100000 then V:=int(V);
  if V=Arrodonir(V) then begin
    Str(V:1:0,s);
    //RealToStringY:= s;
    Resultat:=s;
  end else begin
    {nd:=length(RealToString(Frac(Aprox(Idy))))-2;}
    nd:=6;
    s:=RealToString(Frac(Aprox(Idy)));
    d:=length(s);
    for i:=3 to d do begin
      if Copy(s,i,1)<>'0' then begin
        nd:= i-2;
        Break;
      end;
    end;
    {
    //BEGIN v: 10 01/01/06
    v:=PasarADecimals(V,nd);
    s:=RealToString(V);
    RealToStringY:=s;
    exit;
    //END v: 10 01/01/06
    }
    Str(V:1:nd,s);
    d:=length(s);
    for i:=d downto d-nd do begin
      if Copy(s,i,1)<>'0' then begin
        n:=i;
        //BEGIN v: 10 01/01/06
        if Copy(s,n,1)='.' then n:=n-1;
        //RealToStringY:=Copy(s,1,n);
        Resultat:=Copy(s,1,n);
        //END v: 10 01/01/06
        break;
      end;
      if Copy(s,n,1)='.' then n:=n-1;
      //RealToStringY:=Copy(s,1,n);
      Resultat:=Copy(s,1,n);
    end;
  end;
  i:=Pos('.',Resultat);
  if i<>0 then begin
    Delete(Resultat,i,1);
    Insert(',',Resultat,i);
  end;
  RealToStringY:=Resultat;
end;

function Maxim(Valor1,Valor2:Real):Real; {Funci donats 2 reals torna el gran}
begin
  if Valor1>Valor2 then Maxim:=Valor1 else Maxim:=Valor2;
end;

function Minim(Valor1,Valor2:Real):Real; {Funci donats 2 reals torna el petit}
begin
  if Valor1<Valor2 then Minim:=Valor1 else Minim:=Valor2;
end;

function GetProgramAssociation (Ext:string):string;
var
  reg: TRegistry;
  s : string;
begin
  {l'open pot ser abrir}
  s := '';
  reg := TRegistry.Create;
  reg.RootKey := HKEY_CLASSES_ROOT;
  if reg.OpenKey('.' + ext + '\shell\open\command',false) <> false then begin
    {The open command has been found}
    s := reg.ReadString('');
    reg.CloseKey;
  end else begin
    {perhaps thier is a system file pointer}
    if reg.OpenKey('.' + ext,false) <> false then begin
      s := reg.ReadString('');
      reg.CloseKey;
      if s <> '' then begin
        {A system file pointer was found}
        if reg.OpenKey(s + '\shell\open\command',false) <> false then begin
          s := reg.ReadString('');
        end;
        reg.CloseKey;
      end;
    end;
  end;
  {Delete any command line, quotes and spaces}
  if Pos('%', s) > 0 then Delete(s, Pos('%', s), length(s));
  if ((length(s) > 0) and (s[1] = '"')) then Delete(s, 1, 1);
  if ((length(s) > 0) and (s[length(s)] = '"')) then Delete(s, Length(s), 1);
  while ((length(s) > 0) and ((s[length(s)] = #32) or (s[length(s)] = '"'))) do Delete(s, Length(s), 1);
  result := s;
end;

{FAQ Borland DELPHI- Per associar una extensi EXT a un programa S}
procedure AssociarExtensio(Ext,s:string);
var
  reg: TRegistry;
begin
  reg := TRegistry.Create;
  reg.RootKey := HKEY_CLASSES_ROOT;
  reg.LazyWrite := false;
  {Add Program Support}
  reg.OpenKey('.'+Ext+'\shell\open\command',true);
  {Invoke the program passing the file name as the first parameter}
  reg.WriteString('',s+' %1');
  {Add Icon Display}
  reg.CloseKey;
  reg.OpenKey('.'+Ext+'\DefaultIcon',true);
  {Use the first icon in the executable to display}
  reg.WriteString('',s+',0');
  reg.CloseKey;
  reg.free;
end;

Function CasMay(s: string): string;
var
  i,j: integer;
begin
  J := Length(s);
  For i := 1 to j Do s[i] := Upcase(s[i]);
  CasMay := s;
end;

procedure AALine(x1,y1,x2,y2 : single; color : tcolor; canvas : tcanvas);

  function CrossFadeColor(FromColor,ToColor : TColor; Rate : Single) : TColor;
  var r,g,b : byte;
  begin
    r:=Round(GetRValue(FromColor)*Rate+GetRValue(ToColor)*(1-Rate));
    g:=Round(GetGValue(FromColor)*Rate+GetGValue(ToColor)*(1-Rate));
    b:=Round(GetBValue(FromColor)*Rate+GetBValue(ToColor)*(1-Rate));
    Result:=RGB(r,g,b);
  end;

  procedure hpixel(x : single; y : integer);
  var FadeRate : single;
  begin
    FadeRate:=x-trunc(x);
    with canvas do
    begin
      pixels[trunc(x),y]:=CrossFadeColor(Color,Pixels[Trunc(x),y],1-FadeRate);
      pixels[trunc(x)+1,y]:=CrossFadeColor(Color,Pixels[Trunc(x)+1,y],FadeRate);
    end;
  end;

  procedure vpixel(x : integer; y : single);
  var FadeRate : single;
  begin
    FadeRate:=y-trunc(y);
    with canvas do
    begin
      pixels[x,trunc(y)]:=CrossFadeColor(Color,Pixels[x,Trunc(y)],1-FadeRate);
      pixels[x,trunc(y)+1]:=CrossFadeColor(Color,Pixels[x,Trunc(y)+1],FadeRate);
    end;
  end;

var i : integer;
    ly,lx,currentx,currenty,deltax,deltay,l,skipl : single;
begin
  if (x1<>x2) or (y1<>y2) then
  begin
    currentx:=x1;
    currenty:=y1;
    lx:=abs(x2-x1);
    ly:=abs(y2-y1);

    if lx>ly then
    begin
      l:=trunc(lx);
      deltay:=(y2-y1)/l;
      if x1>x2 then
      begin
        deltax:=-1;
        skipl:=(currentx-trunc(currentx));
      end else
      begin
        deltax:=1;
        skipl:=1-(currentx-trunc(currentx));
      end;
    end else
    begin
      l:=trunc(ly);
      deltax:=(x2-x1)/l;
      if y1>y2 then
      begin
        deltay:=-1;
        skipl:=(currenty-trunc(currenty));
      end else
      begin
        deltay:=1;
        skipl:=1-(currenty-trunc(currenty));
      end;
    end;

    currentx:=currentx+deltax*skipl;
    currenty:=currenty+deltay*skipl;{}

    for i:=1 to trunc(l) do
    begin
      if lx>ly then vpixel(trunc(currentx),currenty) else hpixel(currentx,trunc(currenty));
      currentx:=currentx+deltax;
      currenty:=currenty+deltay;
    end;
  end;
end;


	

//28/03/14 Una nova manera de fer linies antialising. He hagut de posart l'Uses Math
//It is not very hard to implement Xiaolin Wu's anti-aliasing line-rendering algorithm in Delphi. I used the Wikipedia article as a reference when I wrote the following procedure (actually, I just translated the pseudo-code to Delphi and corrected a bug, and added support for a coloured background):
procedure DrawAntialisedLine(Canvas: TCanvas; const AX1, AY1, AX2, AY2: real; const LineColor: TColor);

var
  swapped: boolean;

  procedure plot(const x, y, c: real);
  var
    resclr: TColor;
  begin
    if swapped then
      resclr := Canvas.Pixels[round(y), round(x)]
    else
      resclr := Canvas.Pixels[round(x), round(y)];
    resclr := RGB(round(GetRValue(resclr) * (1-c) + GetRValue(LineColor) * c),
                  round(GetGValue(resclr) * (1-c) + GetGValue(LineColor) * c),
                  round(GetBValue(resclr) * (1-c) + GetBValue(LineColor) * c));
    if swapped then
      Canvas.Pixels[round(y), round(x)] := resclr
    else
      Canvas.Pixels[round(x), round(y)] := resclr;
  end;

  function rfrac(const x: real): real; //inline;
  begin
    rfrac := 1 - frac(x);
  end;

  procedure swap(var a, b: real);
  var
    tmp: real;
  begin
    tmp := a;
    a := b;
    b := tmp;
  end;

var
  x1, x2, y1, y2, dx, dy, gradient, xend, yend, xgap, xpxl1, ypxl1,
  xpxl2, ypxl2, intery: real;
  x: integer;

begin

  x1 := AX1;
  x2 := AX2;
  y1 := AY1;
  y2 := AY2;

  dx := x2 - x1;
  dy := y2 - y1;
  swapped := abs(dx) < abs(dy);
  if swapped then
  begin
    swap(x1, y1);
    swap(x2, y2);
    swap(dx, dy);
  end;
  if x2 < x1 then
  begin
    swap(x1, x2);
    swap(y1, y2);
  end;

  gradient := dy / dx;

  xend := round(x1);
  yend := y1 + gradient * (xend - x1);
  xgap := rfrac(x1 + 0.5);
  xpxl1 := xend;
  ypxl1 := floor(yend);
  plot(xpxl1, ypxl1, rfrac(yend) * xgap);
  plot(xpxl1, ypxl1 + 1, frac(yend) * xgap);
  intery := yend + gradient;

  xend := round(x2);
  yend := y2 + gradient * (xend - x2);
  xgap := frac(x2 + 0.5);
  xpxl2 := xend;
  ypxl2 := floor(yend);
  plot(xpxl2, ypxl2, rfrac(yend) * xgap);
  plot(xpxl2, ypxl2 + 1, frac(yend) * xgap);

  for x := round(xpxl1) + 1 to round(xpxl2) - 1 do
  begin
    plot(x, floor(intery), rfrac(intery));
    plot(x, floor(intery) + 1, frac(intery));
    intery := intery + gradient;
  end;

end;
end.

